package com.hikcreate.controller;

import com.alibaba.fastjson.JSONObject;
import com.hikcreate.drv_photo_pic.DrvPhoto;
import com.hikcreate.drv_photo_pic.VioPic;
import com.hikcreate.entity.PicByte;
import com.hikcreate.service.fdfs.service.FileService;
import com.hikcreate.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;

import javax.imageio.stream.FileImageOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.Date;
import java.util.Map;

import org.springframework.http.*;


/**
 * @author lifuyi
 * @date ${Date}
 * @description
 */
@RestController
@RequestMapping("/pic")
public class PicController {

    @Autowired
    private VioPic vioPic;

    @Autowired
    private DrvPhoto drvPhoto;
    @Autowired
    private FileService fileService;
    @Value("${ftpUrl}")
    private String ftpUrl;


    @GetMapping("/drvPhotoHis")
    public void getHisDrvPhoto(@RequestParam("time") String time, HttpServletResponse response) {
        try {
            boolean result = drvPhoto.getHisDrvPhoto(time);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("result", result);
            response.setContentType("application/json;charset=UTF-8");
            response.getWriter().write(jsonObject.toJSONString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @GetMapping("/testHttp")
    public void testHttp(@RequestParam("param") String param, HttpServletResponse response) {
        try {
            RestTemplate restTemplate = new RestTemplate();
            MultiValueMap<String, String> params = new LinkedMultiValueMap<String, String>();
            params.add("urls", param);
            HttpHeaders headers = new HttpHeaders();
            HttpMethod method = HttpMethod.POST;
            headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
            HttpEntity<MultiValueMap<String, String>> requestEntity = new HttpEntity<>(params, headers);
            ResponseEntity<PicByte> resp = restTemplate.exchange(ftpUrl, method, requestEntity, PicByte.class);
            Map<String, byte[]> map = resp.getBody().getMap();
            //遍历Map
            String path = "/home/pic/";
            File file;
            for (Map.Entry<String, byte[]> entry : map.entrySet()) {
                String[] split = entry.getKey().split("/");
                file = new File(path + split[split.length - 1]);
                if (file.exists()) {
                    file.delete();
                }
                FileImageOutputStream imageOutput = new FileImageOutputStream(file);
                imageOutput.write(entry.getValue(), 0, entry.getValue().length);
                imageOutput.close();
            }
            response.setContentType("application/json;charset=UTF-8");
            response.getWriter().write(path);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @GetMapping("/testIncVio")
    public void testFastDfs(@RequestParam("past") int past) {
        String date = DateUtil.getDate();
        vioPic.getIncrementVioPic(DateUtil.formatDate(DateUtil.getPastDate(new Date(),-past)),date);
    }


}
