package com.hikcreate.drv_photo_pic.impl;

import com.hikcreate.drv_photo_pic.VioPic;
import com.hikcreate.entity.PicByte;
import com.hikcreate.service.fdfs.service.FileService;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.util.Bytes;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.sql.*;
import java.sql.Connection;
import java.util.Map;

@Service("vioPicImpl")
public class VioPicImpl implements VioPic {

    private static Logger logger = LoggerFactory.getLogger(VioPicImpl.class);

    @Value("${hive.url}")
    private String hiveUrl;
    @Value("${hive.user}")
    private String hiveUser;
    @Value("${hive.password}")
    private String hivePassWord;
    @Value("${increment.vio.pic.sql}")
    private String incrementVioPicSql;
    @Value("${hbase.zookeeper.property.clientPort}")
    private String hbaseAddress;
    @Value("${hbase.zookeeper.quorum}")
    private String hbaseZkQuorum;
    @Value("${hbase.master}")
    private String hbaseMaster;
    @Value("${hbase.vio.table}")
    private String vioTableStr;
    @Value("${ftpUrl}")
    private String ftpUrl;


    @Autowired
    private static FileService fileService;

    private String rowkey;
    private static TableName vioTableName;
    private static Table vioTable;
    private static Configuration hbaseConf;
    private static org.apache.hadoop.hbase.client.Connection hbaseConn;

    private static String hphm;
    private static String hpzl;
    private static String wfsj;
    private static String url1;
    private static String url2;
    private static String url3;
    private static Put put;
    private static MultiValueMap<String, String> params;
    private static HttpEntity<MultiValueMap<String, String>> requestEntity;
    private static HttpHeaders headers;
    private static HttpMethod method;
    private static RestTemplate restTemplate;
    private static String[] colValue;

    /**
     * 增量同步违法图片
     */
    @Override
    public synchronized void getIncrementVioPic(String startDay, String endDay) {
        try {
            String JDBC_DRIVER = "org.apache.hive.jdbc.HiveDriver";
            Class.forName(JDBC_DRIVER);
            logger.info(hiveUrl + "-----------" + hivePassWord + "--------" + hiveUser);
            Connection connection = DriverManager.getConnection(hiveUrl, hiveUser, hivePassWord);
            PreparedStatement pstm = connection.prepareStatement(incrementVioPicSql);
            pstm.setString(1, endDay);
            pstm.setString(2, startDay);
//            incrementVioPicSql="SELECT a.ccarnumber hphm,a.clicensetype hpzl,b.wfsj wfsj,a.cpic1path url1,a.cpic2path url2,a.cpic3path url3 from " +
//                    "(SELECT * from kakou.vio_violation_pic_his_ods WHERE substr(export_time,0,10)<='"+endDay+"'  and substr(export_time,0,10)>'"+startDay+"') a " +
//                    "INNER JOIN (SELECT * from default.vio_surveil_all WHERE clsj='null' or clsj='' or clsj is null) b WHERE a.ccarnumber=b.hphm " +
//                    "and a.clicensetype=b.hpzl and substr(a.dillegaldate,0,16)=substr(b.wfsj,0,16)";
//            PreparedStatement pstm = connection.prepareStatement(incrementVioPicSql);
            logger.info(pstm.toString());
            logger.info(startDay);
            logger.info(endDay);
            ResultSet resultSet = pstm.executeQuery();
            hbaseConf = HBaseConfiguration.create();
            hbaseConf.set("hbase.zookeeper.property.clientPort", hbaseAddress);
            hbaseConf.set("hbase.zookeeper.quorum", hbaseZkQuorum);
            hbaseConf.set("hbase.master", hbaseMaster);
            hbaseConn = ConnectionFactory.createConnection(hbaseConf);
            logger.info("success connection --------------------------");
            vioTableName = TableName.valueOf(vioTableStr);
            vioTable = hbaseConn.getTable(vioTableName);
            restTemplate = new RestTemplate();
            headers = new HttpHeaders();
            method = HttpMethod.POST;
            headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
            logger.info("dgewhdjdddddddddddddd-------------");
            loop1:
            while (resultSet.next()) {
                logger.info("数据库查询出东西了------------");
                hphm = resultSet.getString("hphm");
                hpzl = resultSet.getString("hpzl");
                wfsj = resultSet.getString("wfsj");
                url1 = resultSet.getString("url1");
                url2 = resultSet.getString("url2");
                url3 = resultSet.getString("url3");
                rowkey = hphm + "#" + hpzl + "#" + wfsj;
                Get get = new Get(rowkey.getBytes());
                put = new Put(rowkey.getBytes());
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl1"));
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl2"));
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl3"));
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl4"));
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl5"));
                get.addColumn(Bytes.toBytes("useful"), Bytes.toBytes("ftpUrl6"));
                Result result = vioTable.get(get);
                colValue = new String[6];
                for (Cell cell : result.rawCells()) {
                    String colName = Bytes.toString(cell.getQualifierArray(), cell.getQualifierOffset(), cell.getQualifierLength());
                    String value = Bytes.toString(cell.getValueArray(), cell.getValueOffset(), cell.getValueLength());
                    //保存值
                    switch (colName) {
                        case "ftpUrl1":
                            colValue[0] = value;
                        case "ftpUrl2":
                            colValue[1] = value;
                        case "ftpUrl3":
                            colValue[2] = value;
                        case "ftpUrl4":
                            colValue[3] = value;
                        case "ftpUrl5":
                            colValue[4] = value;
                        case "ftpUrl6":
                            colValue[5] = value;
                    }
                }
                logger.info("查询get结果:"+colValue.toString());
                //插入数据操作
                //url1
                if (url1 != null && !"".equals(url1)) {
                    //判断之前是否已经插入过图片了，防止多次插入
                    if (url1.equals(colValue[0]) || url1.equals(colValue[3])) {
                        continue loop1;
                    }
                    if (colValue[0] == null || "".equals(colValue[0])) {
                        //url1插入ftpurl1
                        putData("ftpUrl1", "fastDfsUrl1", url1, ftpUrl);
                    } else {
                        if (colValue[3] == null || "".equals(colValue[3])) {
                            //url1插入ftpurl4
                            putData("ftpUrl4", "fastDfsUrl4", url1, ftpUrl);
                        }
                    }
                }
                if (url2 != null && !"".equals(url2)) {
                    if (url2.equals(colValue[1]) || url2.equals(colValue[4])) {
                        continue loop1;
                    }
                    if (colValue[1] == null || "".equals(colValue[1])) {
                        //url1插入ftpurl1
                        putData("ftpUrl2", "fastDfsUrl2", url2, ftpUrl);
                    } else {
                        if (colValue[4] == null || "".equals(colValue[4])) {
                            //url1插入ftpurl4
                            putData("ftpUrl5", "fastDfsUrl5", url2, ftpUrl);
                        }
                    }
                }
                if (url3 != null && !"".equals(url3)) {
                    if (url3.equals(colValue[2]) || url3.equals(colValue[5])) {
                        continue loop1;
                    }
                    if (colValue[2] == null || "".equals(colValue[2])) {
                        //url1插入ftpurl1
                        putData("ftpUrl3", "fastDfsUrl3", url3, ftpUrl);
                    } else {
                        if (colValue[5] == null || "".equals(colValue[5])) {
                            //url1插入ftpurl4
                            putData("ftpUrl6", "fastDfsUrl6", url3, ftpUrl);
                        }
                    }
                }
                vioTable.put(put);
            }
            resultSet.close();
            pstm.close();
            connection.close();
            logger.info("执行完毕：---------------------");
        } catch (Exception e) {
            e.printStackTrace();
            Writer writer = new StringWriter();
            e.printStackTrace(new PrintWriter(writer));
            logger.error("打印错误:" + writer.toString());
        } finally {
            if (vioTable != null) {
                try {
                    vioTable.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (hbaseConn != null) {
                try {
                    hbaseConn.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }


    private static void putData(String hbaseFtpCol, String hbaseFastCol, String url, String ftpUrl) {
        put.addColumn("useful".getBytes(), hbaseFtpCol.getBytes(), url.getBytes());
        //存fastDfs
        params = new LinkedMultiValueMap<String, String>();
        params.add("urls", url);
        requestEntity = new HttpEntity<>(params, headers);
        ResponseEntity<PicByte> resp = restTemplate.exchange(ftpUrl, method, requestEntity, PicByte.class);
        Map<String, byte[]> map = resp.getBody().getMap();
        if(map.size()>0){
            for (Map.Entry<String, byte[]> entry : map.entrySet()) {
                String[] arr = url.split("/");
                String fastDfsUrl = fileService.uploadFile(entry.getValue(), arr[arr.length - 1]);
                logger.info("fastdfs地址"+fastDfsUrl);
                put.addColumn("useful".getBytes(), hbaseFastCol.getBytes(), fastDfsUrl.getBytes());
            }
        }else {
            logger.info("此ftp地址数据为空：=========================="+url);
        }


    }

}
