package com.hikcreate.schedul;

import com.hikcreate.drv_photo_pic.DrvPhoto;
import com.hikcreate.drv_photo_pic.VioPic;
import com.hikcreate.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class PicSchedule {

    @Autowired
    private DrvPhoto drvPhoto;
    @Autowired
    private VioPic vioPic;
    @Value("${pastDay}")
    private int pastDay;



    /**
     * 每天早上10点同步增量数据
     */
    @Scheduled(cron = "0 10 * * * *")
    public void getIncrementDrvPhoto(){
        drvPhoto.getIncrementDrvPhoto();
    }


//    @Scheduled(cron = "0 10 * * * *")
    public void getIncrementVioPic(){
        String date = DateUtil.getDate();
        vioPic.getIncrementVioPic(date,DateUtil.formatDate(DateUtil.getPastDate(new Date(),-pastDay)));
    }

}
